]> git.pld-linux.org Git - packages/apache.git/blob - apache.init
- no daemon for flush-logs either
[packages/apache.git] / apache.init
1 #!/bin/sh
2 #
3 # apache        Apache Web Server
4 #
5 # chkconfig:    345 85 15
6 # description:  Apache is a World Wide Web server.  It is used to serve \
7 #               HTML files and CGI.
8 # processname:  httpd
9 # pidfile:      /var/run/httpd.pid
10 # config:       /etc/httpd/apache.conf
11
12 # Source function library
13 . /etc/rc.d/init.d/functions
14
15 # Get network config
16 . /etc/sysconfig/network
17
18 # Get service config
19 [ -f /etc/sysconfig/httpd ] && . /etc/sysconfig/httpd
20
21 # Check that networking is up.
22 if is_yes "${NETWORKING}"; then
23         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
24                 msg_network_down httpd
25                 exit 1
26         fi
27 else
28         exit 0
29 fi
30
31 [ -z "$HTTPD_MPM" ] && HTTPD_MPM="prefork"
32
33 if [ -n "${HTTPD_CONF}" ]; then
34         if [ -d "${HTTPD_CONF}" ] || [ -f "${HTTPD_CONF}" ]; then
35                 CFG="-f ${HTTPD_CONF}"
36         else
37                 echo "error: HTTPD_CONF='$HTTPD_CONF': not a file, not a directory"
38                 exit 1
39         fi
40 fi
41
42 start() {
43         # Check if the service is already running?
44         if [ ! -f /var/lock/subsys/httpd ]; then
45                 msg_starting httpd.${HTTPD_MPM}
46                 daemon /usr/sbin/httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS
47                 RETVAL=$?
48                 [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
49         else
50                 msg_already_running httpd.${HTTPD_MPM}
51         fi
52 }
53
54 stop() {
55         # Stop daemons.
56         if [ -f /var/lock/subsys/httpd ]; then
57                 msg_stopping httpd.${HTTPD_MPM}
58                 killproc --pidfile httpd.pid httpd.${HTTPD_MPM}
59                 rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
60         else
61                 msg_not_running httpd.${HTTPD_MPM}
62         fi
63 }
64
65 condrestart() {
66         if [ -f /var/lock/subsys/httpd ]; then
67                 stop
68                 start
69         else
70                 msg_not_running httpd.${HTTPD_MPM}
71                 RETVAL=$1
72         fi
73 }
74
75 RETVAL=0
76 # See how we were called.
77 case "$1" in
78   start)
79         start
80         ;;
81   stop)
82         stop
83         ;;
84   status)
85         status httpd.${HTTPD_MPM}
86         RETVAL=$?
87         /usr/sbin/httpd.${HTTPD_MPM} $CFG -S
88         ;;
89   restart)
90         stop
91         start
92         ;;
93   try-restart)
94         condrestart 0
95         ;;
96   reload|force-reload|graceful)
97         if [ -f /var/lock/subsys/httpd ]; then
98                 run_cmd "Checking httpd.${HTTPD_MPM} configuration" /usr/sbin/httpd.${HTTPD_MPM} $CFG -t
99                 RETVAL=$?
100                 if [ $RETVAL -eq 0 ]; then
101                         msg_reloading httpd.${HTTPD_MPM}
102                         busy
103                         /usr/sbin/httpd.${HTTPD_MPM} $CFG -k graceful
104                         RETVAL=$?
105                         [ $RETVAL -eq 0 ] && ok || fail
106                 fi
107         else
108                 msg_not_running httpd.${HTTPD_MPM}
109                 RETVAL=7
110         fi
111         ;;
112   flush-logs)
113         if [ -f /var/lock/subsys/httpd ]; then
114                 msg_reloading httpd.${HTTPD_MPM}
115
116                 /usr/sbin/httpd.${HTTPD_MPM} -t >/dev/null 2>&1
117                 RETVAL=$?
118                 if [ $RETVAL -eq 0 ]; then
119                         /usr/sbin/httpd.${HTTPD_MPM} $CFG -k graceful
120                         RETVAL=$?
121                         [ $RETVAL -eq 0 ] && ok || fail
122                 else
123                         fail
124                         echo >&2 "Configuration file syntax test failed."
125                 fi
126         fi
127         ;;
128   *)
129         msg_usage "$0 {start|stop|restart|try-restart|reload|force-reload|graceful|status}"
130         exit 3
131         ;;
132 esac
133
134 exit $RETVAL
This page took 0.050561 seconds and 4 git commands to generate.